找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 889|回复: 0

[分享] Creating a table of block attributes in AutoCAD using .NET - Part 1

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-5-11 17:05:33 来自手机 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
本帖最后由 csharp 于 2014-5-12 08:11 编辑

http://through-the-interface.typepad.com/through_the_interface/2007/06/creating_an_aut_2.html

Creating a table of block attributes in AutoCAD using .NET - Part 1
This post was inspired by suggestions from a few different people (you know who you are! :-). I'm going to take it in two parts: this post will focus on creating a table automatically that lists the values of attribute references included in block references in the modelspace that point to a particular block table record selected by the user. Phew. The next post will add some functionality to create a "total" of one of the columns in the table we create, by using a table formula that performs a sum of the appropriate cells.
The below code is actually quite similar in behaviour to the Table sample on the ObjectARX SDK and also the EATTEXT command inside AutoCAD - both of which will help you create tables from block attributes. I wrote this code in AutoCAD 2007 (and it should work just fine in 2008, also). I haven't tested against prior versions.
One item of note is the ability to either embed or link the data placed in the table. "Embedding" means we just take a copy of the attribute values and place them as plain text in the cells; "linking" means we use a field to create a reference from the cell to the attribute's value (using the technique shown in the previous post).
The code is quite lengthy, but I've done my best to comment it to make it more clear what's going on. Here's the C# code:
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;
using System.Collections.Specialized;
using System;

namespace TableCreation
{
  public class Commands
  {
    // Set up some formatting constants
    // for the table

    const double colWidth = 15.0;
    const double rowHeight = 3.0;
    const double textHeight = 1.0;
    const CellAlignment cellAlign =
      CellAlignment.MiddleCenter;

    // Helper function to set text height
    // and alignment of specific cells,
    // as well as inserting the text

    static public void SetCellText(
      Table tb,
      int row,
      int col,
      string value
    )
    {
      tb.SetAlignment(row, col, cellAlign);
      tb.SetTextHeight(row, col, textHeight);
      tb.SetTextString(row, col, value);
    }

    [CommandMethod("BAT")]
    static public void BlockAttributeTable()
    {
      Document doc =
        Application.DocumentManager.MdiActiveDocument;
      Database db = doc.Database;
      Editor ed = doc.Editor;

      // Ask for the name of the block to find

      PromptStringOptions opt =
        new PromptStringOptions(
          "\nEnter name of block to list: "
        );
      PromptResult pr = ed.GetString(opt);

      if (pr.Status == PromptStatus.OK)
      {
        string blockToFind =
          pr.StringResult.ToUpper();
        bool embed = false;

        // Ask whether to embed or link the data

        PromptKeywordOptions pko =
          new PromptKeywordOptions(
            "\nEmbed or link the attribute values: "
          );

        pko.AllowNone = true;
        pko.Keywords.Add("Embed");
        pko.Keywords.Add("Link");
        pko.Keywords.Default = "Embed";
        PromptResult pkr =
          ed.GetKeywords(pko);

        if (pkr.Status == PromptStatus.None ||
            pkr.Status == PromptStatus.OK)
        {
          if (pkr.Status == PromptStatus.None ||
              pkr.StringResult == "Embed")
            embed = true;
          else
            embed = false;
        }

        Transaction tr =
          doc.TransactionManager.StartTransaction();
        using (tr)
        {
          // Let's check the block exists

          BlockTable bt =
            (BlockTable)tr.GetObject(
              doc.Database.BlockTableId,
              OpenMode.ForRead
            );

          if (!bt.Has(blockToFind))
          {
            ed.WriteMessage(
              "\nBlock "
              + blockToFind
              + " does not exist."
            );
          }
          else
          {
            // And go through looking for
            // attribute definitions

            StringCollection colNames =
              new StringCollection();

            BlockTableRecord bd =
              (BlockTableRecord)tr.GetObject(
                bt[blockToFind],
                OpenMode.ForRead
              );
            foreach (ObjectId adId in bd)
            {
              DBObject adObj =
                tr.GetObject(
                  adId,
                  OpenMode.ForRead
                );

              // For each attribute definition we find...

              AttributeDefinition ad =
                adObj as AttributeDefinition;
              if (ad != null)
              {
                // ... we add its name to the list

                colNames.Add(ad.Tag);
              }
            }
            if (colNames.Count == 0)
            {
              ed.WriteMessage(
                "\nThe block "
                + blockToFind
                + " contains no attribute definitions."
              );
            }
            else
            {
              // Ask the user for the insertion point
              // and then create the table

              PromptPointResult ppr =
                ed.GetPoint(
                  "\nEnter table insertion point: "
                );

              if (ppr.Status == PromptStatus.OK)
              {
                Table tb = new Table();
                tb.TableStyle = db.Tablestyle;
                tb.NumRows = 1;
                tb.NumColumns = colNames.Count;
                tb.SetRowHeight(rowHeight);
                tb.SetColumnWidth(colWidth);
                tb.Position = ppr.Value;

                // Let's add our column headings

                for (int i = 0; i < colNames.Count; i++)
                {
                  SetCellText(tb, 0, i, colNames);
                }

                // Now let's search for instances of
                // our block in the modelspace

                BlockTableRecord ms =
                  (BlockTableRecord)tr.GetObject(
                    bt[BlockTableRecord.ModelSpace],
                    OpenMode.ForRead
                  );

                int rowNum = 1;
                foreach (ObjectId objId in ms)
                {
                  DBObject obj =
                    tr.GetObject(
                      objId,
                      OpenMode.ForRead
                    );
                  BlockReference br =
                    obj as BlockReference;
                  if (br != null)
                  {
                    BlockTableRecord btr =
                      (BlockTableRecord)tr.GetObject(
                        br.BlockTableRecord,
                        OpenMode.ForRead
                      );
                    using (btr)
                    {
                      if (btr.Name.ToUpper() == blockToFind)
                      {
                        // We have found one of our blocks,
                        // so add a row for it in the table

                        tb.InsertRows(
                          rowNum,
                          rowHeight,
                          1
                        );

                        // Assume that the attribute refs
                        // follow the same order as the
                        // attribute defs in the block

                        int attNum = 0;
                        foreach (
                          ObjectId arId in
                          br.AttributeCollection
                        )
                        {
                          DBObject arObj =
                            tr.GetObject(
                              arId,
                              OpenMode.ForRead
                            );
                          AttributeReference ar =
                            arObj as AttributeReference;
                          if (ar != null)
                          {
                            // Embed or link the values

                            string strCell;
                            if (embed)
                            {
                              strCell = ar.TextString;
                            }
                            else
                            {
                              string strArId =
                                arId.ToString();
                              strArId =
                                strArId.Trim(
                                  new char[] { '(', ')' }
                                );
                              strCell =
                                "%<\\AcObjProp Object("
                                  + "%<\\_ObjId "
                                  + strArId
                                  + ">%).TextString>%";
                            }
                            SetCellText(
                              tb,
                              rowNum,
                              attNum,
                              strCell
                            );
                          }
                          attNum++;
                        }
                        rowNum++;
                      }
                    }
                  }
                }
                tb.GenerateLayout();

                ms.UpgradeOpen();
                ms.AppendEntity(tb);
                tr.AddNewlyCreatedDBObject(tb, true);
                tr.Commit();
              }
            }
          }
        }
      }
    }
  }
}

To test the code, I created a block called "DATA" containing attribute definitions for NAME, PARTNUM, MATERIAL and COST. I then created blocks corresponding to the data we had previously hard-coded.
Here's what happens when I used the BAT command on this data to create two tables - the top with "embedded" values, the bottom with them "linked":
0.jpg
In the next post we'll add a "Total" row at the bottom of the table, and use a formula to calculate the sum of a particular column (the logical one being COST, as it's numerical).


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2025-1-6 01:12 , Processed in 0.428359 second(s), 31 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表